/*
 * BME280_math.inc
 *
 *  Created: 10.10.2020 21:15:00
 *   Author: Steffen Hrhold
 */ 


 bme280_calc_temperatur:		
; 1.) Berechnung Temperatur [var2]
; get (raw_T)
;================================================================================================================
		lds		r16,(ramBME280_rawTEMP+0)		; XLSB Temperature raw data
		lds		r17,(ramBME280_rawTEMP+1)		;  LSB Temperature raw data 
		lds		r18,(ramBME280_rawTEMP+2)		;  MSB Temperature raw data

; ((raw_T)>>3) | raw_T /8
;================================================================================================================
		asr		r18								; /2
		ror		r17
		ror		r16
		asr		r18								; /4
		ror		r17
		ror		r16
		asr		r18								; /8
		ror		r17
		ror		r16
		load_p	Y,(ramBME280_var1)
; cache to calc [var1]
;================================================================================================================
		st		Y+,r16							; XLSB ((raw_T)>>3)
		st		Y+,r17							;  LSB ((raw_T)>>3)
		st		Y+,r18							;  MSB ((raw_T)>>3)
; ((raw_T)>>4) | raw_T/16
;================================================================================================================
		asr		r18								; /16
		ror		r17								; MSB (raw_T)
		ror		r16								; LSB (raw_T)

; get ((dig_T1)
;================================================================================================================
		lds		r20,(ramBME280_DIG_T1+0)		;  XLSB Temperature comp_T1		unsigned
		lds		r21,(ramBME280_DIG_T1+1)		;   LSB Temperature comp_T1		unsigned		
; var2 = ( ((raw_T)>>4) - (dig_T1) )
;================================================================================================================
		sub		r16,r20							; r16 = B.0
		sbc		r17,r21							; r17 = B.1
; cache to calc [var1] ((dig_T1)<<1)
;================================================================================================================
		clr		r22
		lsl		r20								; XLSB ((dig_T1)<<1)
		rol		r21								;  LSB ((dig_T1)<<1)
		rol		r22								;  MSB ((dig_T1)<<1)
		load_p	Y,(ramBME280_var3)	
		st		Y+,r20							; XLSB ((dig_T1)<<1)
		st		Y+,r21							;  LSB ((dig_T1)<<1)
		st		Y+,r22							;  MSB ((dig_T1)<<1)
;  (((raw_T)>>4) - (dig_T1) ))^2
;================================================================================================================
		mov		r20,r16							; r20 = A.0
		mov		r21,r17							; r21 = A.1
		rcall	muls_16x16					;					[ MULS_16x16_32 ]

;  ( (((raw_T)>>4) - (dig_T1) ))^2 )>>12		[20bit]
; ((RESULT) /4096) oder ((RESULT)>>12)
;================================================================================================================
		asr		r5
		ror		r4
		ror		r3
		asr		r5
		ror		r4
		ror		r3
		asr		r5
		ror		r4
		ror		r3
		asr		r5
		ror		r4
		ror		r3
		mov		r20,r3						; r20 = A.0
		mov		r21,r4						; r21 = A.1
		mov		r22,r5						; r22 = A.2
		
		lds		r16,(ramBME280_DIG_T3+0)	; r16 = B.0
		lds		r17,(ramBME280_DIG_T3+1)	; r17 = B.1	
		rcall	muls_24x16					;					[ MULS_24x16_40 ]

; ((RESULT) /16384) oder ((RESULT)>>14)
;================================================================================================================
		clr		r7
		sbrc	r6,7
		com		r7
		lsl		r3
		rol		r4
		rol		r5
		rol		r6
		rol		r7
		lsl		r3
		rol		r4
		rol		r5
		rol		r6
		rol		r7
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var2)				; [32bit]		real->[26bit]
		st		Y+,r4
		st		Y+,r5
		st		Y+,r6
		st		Y+,r7
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var2]%%

; ( (ramBME280_var1) - (ramBME280_var3)	)
;================================================================================================================
		lds		r20,((ramBME280_var1)+0)			; LSB	((raw_T)>>3)
		lds		r21,((ramBME280_var1)+1)			;  :	((raw_T)>>3)
		lds		r22,((ramBME280_var1)+2)			; MSB	((raw_T)>>3)
		clr		r23									; r23 = A.3
		
		lds		r16,((ramBME280_var3)+0)			; LSB	((dig_T1)>>1)
		lds		r17,((ramBME280_var3)+1)			;  :	((dig_T1)>>1)
		lds		r18,((ramBME280_var3)+2)			; MSB	((dig_T1)>>1)
		clr		r19									; r19 = B.3
		sbrc	r18,7
		ser		r19				; pos/neg

; ( ((raw_T)>>3) - ((dig_T1)>>1) )
;================================================================================================================
		sub		r20,r16						; r20 = A.0				
		sbc		r21,r17						; r21 = A.1
		sbc		r22,r18						; r22 = A.2
		sbc		r23,r19						; r23 = A.3

		lds		r16,(ramBME280_DIG_T2+0)	; r16 = B.0
		lds		r17,(ramBME280_DIG_T2+1)	; r17 = B.1
		mov		r18,zero					; r18 = B.2
		mov		r19,zero					; r19 = B.3

; ( ( ((raw_T)>>3) - ((dig_T1)>>1) ) * (dig_T1) )
;================================================================================================================
		rcall	muls_24x24							;					[ MULS_24x24_48 ]
; var1_T = ( ( ( ((raw_T)>>3) - ((dig_T1)>>1) ) * (dig_T1) ) >>11 )
; ((Ergebnis) /2048) oder ((Ergebnis)>>11)
;================================================================================================================
		asr		r7
		ror		r6
		ror		r5
		ror		r4
		ror		r3
		asr		r7
		ror		r6
		ror		r5
		ror		r4
		ror		r3
		asr		r7
		ror		r6
		ror		r5
		ror		r4
		ror		r3

; T_fine = var1 + var2
;================================================================================================================
		load_p	Y,(ramBME280_var1)
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
		st		Y+,r6
		load_p	Y,(ramBME280_var2)
		ld		r16,Y+
		ld		r17,Y+
		ld		r18,Y+
		ld		r19,Y+
		add		r16,r3
		adc		r17,r4
		adc		r18,r5
		adc		r19,r6
; store Result of (T_fine)
;================================================================================================================
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_T_fine)		; --> [T_fine]
		st		Y+,r16						; r16 = B.0
		st		Y+,r17						; r17 = B.1
		st		Y+,r18						; r18 = B.2
		st		Y+,r19						; r19 = B.3
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[T_fine]%%

		movw	r20,r16						; r20 = A.0		--> T_fine
		movw	r22,r18						; r21 = A.1
											; r22 = A.2
											; r23 = A.3

;										; --> (5)
		ldi		r16,(5)						; r16 = B.0	

; TEMP = (((T_fine * 5) + 128) >> 8)
;================================================================================================================
		rcall	muls_32x8				; --> (T_fine) x (5)			[ MULS_32x8_40 ]
		ldi		r16,128
		add		r2,r16					; --> +128
		adc		r3,zero
		adc		r4,zero
		adc		r5,zero
		adc		r6,zero

; store Result of (TEMP)
;================================================================================================================
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_TEMP)				; --> [TEMP]
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
		st		Y+,r6
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[TEMP]%%



;###############################################################################################################
;***************************************************************************************************************
 bme280_calc_pressure:		; Berechnung Luftdruck
; 1.) Berechnung 		var1 = ( ((T_fine)/2) - 64000)
;================================================================================================================
		load_p	Y,(ramBME280_T_fine)	; --> T_fine
		ld		r20,Y+
		ld		r21,Y+
		ld		r22,Y+
		ld		r23,Y+

; ((T_fine)/2)
;================================================================================================================
		asr		r23
		ror		r22
		ror		r21
		ror		r20

; (T_fine/2)-64000
;================================================================================================================
		subi	r20,byte1(64000)
		sbci	r21,byte2(64000)
		sbci	r22,byte3(64000)
		sbci	r23,byte4(64000)
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var1)			; store --> [var1]
		st		Y+,r20
		st		Y+,r21
		st		Y+,r22
		st		Y+,r23
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var1]%%

; 2.) Berechnung var2 = ( ( (((var1)>>2) * ((var1)>>2)) >>11) * (dig_P6) )
; Rechnung		(Term1) = ((var1)>>2)
;================================================================================================================
		asr		r23
		ror		r22
		ror		r21
		ror		r20
		asr		r23					; r23 = A.3
		ror		r22					; r22 = A.2
		ror		r21					; r21 = A.1
		ror		r20					; r20 = A.0		--> ((var1)>>2)
; Rechnung		(Term2) = (Term1) * (Term1)			--> quadrieren
;================================================================================================================
		movw	r16,r20				; r19:r16		--> ((var1)>>2)
		movw	r18,r22				; = B.3:B.0
		rcall	muls_32x32

; Rechnung		(Term3) = (Term2)>>11
;================================================================================================================
		asr		r7
		ror		r6
		ror		r5
		ror		r4
		ror		r3			; --> /512
		asr		r7
		ror		r6
		ror		r5			
		ror		r4
		ror		r3			; --> /1024
		asr		r7
		ror		r6
		ror		r5
		ror		r4
		ror		r3			; --> /2048	
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var1_P2)	; store --> [var1_P2]
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
		st		Y+,r6
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var1_P2]%%

; Rechnung		(Term4)	= (Term3) * dig_P6
;================================================================================================================
		load_p	Y,(ramBME280_DIG_P6)	; load --> dig_P6
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1

		mov		r20,r3					; r20 = A.0
		mov		r21,r4					; r21 = A.1
		mov		r22,r5					; r22 = A.2
		mov		r23,r6					; r23 = A.3
		rcall	muls_32x16
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var2)			; store --> [var2]
		st		Y+,r2
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var2]%%

; 3.) Berechnung (var2)NEU) = ( (var2) + ( ((var1) * (dig_P5)) <<1) )
; Rechnung		(Term1) = (var1) * (dig_P5)
;================================================================================================================
		load_p	Y,(ramBME280_var1)		; load --> (var1)
		ld		r20,Y+					; r20 = A.0
		ld		r21,Y+					; r21 = A.1
		ld		r22,Y+					; r22 = A.2
		ld		r23,Y+					; r23 = A.3

		load_p	Y,(ramBME280_DIG_P5)	; load --> dig_P5
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		rcall	muls_32x16

; Rechnung		(Term2) = (Term1) <<1
;================================================================================================================
		lsl		r2
		rol		r3
		rol		r4
		rol		r5
		rol		r6

; Rechnung		((var2)NEU) = (var2) + (Term2)
;================================================================================================================
		load_p	Y,(ramBME280_var2)		; load --> (var2)
		ld		r20,Y+					; r20 = A.0
		ld		r21,Y+					; r21 = A.1
		ld		r22,Y+					; r22 = A.2
		ld		r23,Y+					; r23 = A.3
		add		r20,r2
		adc		r21,r3
		adc		r22,r4
		adc		r23,r5
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var2)			; store --> [var2]
		st		Y+,r20
		st		Y+,r21
		st		Y+,r22
		st		Y+,r23
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var2]%%

; 4.) Berechnung	((var2)NEU) = ((var2)>>2) + ((dig_P4))<<16)		
; Rechnung		(Term1) = ((var2)>>2)
;================================================================================================================
		asr		r23
		ror		r22
		ror		r21
		ror		r20						; >>1	-->	/2
		asr		r23
		ror		r22
		ror		r21
		ror		r20						; >>1	-->	/4

; Rechnung		((var2)NEU) = (Term1) + (dig_P4)<<16)
;================================================================================================================		
		load_p	Y,(ramBME280_DIG_P4)	; load --> dig_P4
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		add		r20,zero
		adc		r21,zero
		adc		r22,r16
		adc		r23,r17
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var2)			; store --> [var2]
		st		Y+,r20
		st		Y+,r21
		st		Y+,r22
		st		Y+,r23
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var2]%%

; 5.) Berechnung	((var1)NEU) = {  ( ((dig_P3) * ((var2_P2)>>2))>>3 ) + ( (dig_P2 * var1)>>1 )  } >>18
; Rechnung		(Term1) = ((var1_P2)>>2)
;================================================================================================================		
		load_p	Y,(ramBME280_var1_P2)	; load --> var1_P2
		ld		r20,Y+					; r20 = A.0
		ld		r21,Y+					; r21 = A.1
		ld		r22,Y+					; r22 = A.2
		ld		r23,Y+					; r23 = A.3
		asr		r23
		ror		r22
		ror		r21
		ror		r20						; >>1	-->	/2
		asr		r23
		ror		r22
		ror		r21
		ror		r20						; >>1	-->	/4

; Rechnung		(Term2) = (dig_P3) * (Term1)
;================================================================================================================
		load_p	Y,(ramBME280_DIG_P3)	; load --> dig_P3
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		rcall	muls_32x16

; Rechnung		(Term3) = (Term2)>>3
;================================================================================================================
		asr		r6
		ror		r5
		ror		r4
		ror		r3
		ror		r2			; >>1	--> /2
		asr		r6
		ror		r5
		ror		r4
		ror		r3
		ror		r2			; >>1	--> /4
		asr		r6
		ror		r5
		ror		r4
		ror		r3
		ror		r2			; >>1	--> /8
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var3)	; cache store --> [var3]
		st		Y+,r2
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var3]%%

; Rechnung		(Term4)	= (dig_P2 * var1)>>1
;================================================================================================================
		load_p	Y,(ramBME280_DIG_P2)	; load -->	(dig_P2)
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1

		load_p	Y,(ramBME280_var1)		; load -->	(var1)
		ld		r20,Y+					; r20 = A.0
		ld		r21,Y+					; r21 = A.1
		ld		r22,Y+					; r22 = A.2
		ld		r23,Y+					; r23 = A.3
		rcall	muls_32x16
		asr		r6
		ror		r5
		ror		r4
		ror		r3
		ror		r2			; >>1	--> /2

; Rechnung		(Term5)	= (Term3) + (Term4)
;================================================================================================================
		load_p	Y,(ramBME280_var3)		; load -->	(var3) -> (Term3)
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		ld		r18,Y+					; r18 = B.2
		ld		r19,Y+					; r19 = B.3
		add		r2,r16
		adc		r3,r17
		adc		r4,r18
		adc		r5,r19
		
; Rechnung		((var1)NEU) = (Term5)>>18		(r2:r3 fall out)>>16 + >>2
;================================================================================================================
		clr		r6
		sbrc	r5,7
		com		r6
		mov		r7,r6
		asr		r7
		ror		r6
		ror		r5
		ror		r4			; >>1	--> /2
		asr		r7
		ror		r6
		ror		r5
		ror		r4			; >>1	--> /4
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var1)	; cache store --> [var1]
		st		Y+,r4
		st		Y+,r5
		st		Y+,r6
		st		Y+,r7
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var1]%%

; 6.) Berechnung	((var1)NEU) = {  ( ((32768) + (var1)) * (dig_P1) )>>15  } 
; Rechnung		(Term1) = (32768) + (var1)
;================================================================================================================
		ldi		r20,BYTE1(32768)
		ldi		r21,BYTE2(32768)
		ldi		r22,BYTE3(32768)
		ldi		r23,BYTE4(32768)
		add		r20,r4					; r20 = A.0
		adc		r21,r5					; r21 = A.1
		adc		r22,r6					; r22 = A.2
		adc		r23,r7					; r23 = A.3

; Rechnung		(Term2) = (Term1) * (dig_P1)
;================================================================================================================
		load_p	Y,(ramBME280_DIG_P1)	; load -->	(dig_P1)
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		rcall	mulsu_32x16

; Rechnung:		(var1)NEU) = (Term2)>>15			>>8 and <<1 and >>8
;================================================================================================================
		lsl		r3
		rol		r4
		rol		r5
		rol		r6
		rol		r7
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var1)			; store --> [var1]
		st		Y+,r4
		st		Y+,r5
		st		Y+,r6
		st		Y+,r7
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var1]%%

; 7.) Case IF var1_P == 0
;================================================================================================================
		cp		r7,zero
		cpc		r6,zero
		cpc		r5,zero
		cpc		r4,zero
		brne	bme280_calc_pressure_ok
; bme280_calc_pressure_error_end:

;		hier fehlt die Fehlerbehandlung
;		eventuell Fehlerflags setzen
;		RETURN: 0
		ret

bme280_calc_pressure_ok:
; 8.) Berechnung	(p) = {  ( ( (1048576) - (raw_PRESSURE) ) - ((var2)>>12) ) *3125  } 
;================================================================================================================
; Rechnung		(Term1) = ( (1048576) - (raw_PRESSURE) )
;================================================================================================================
		load_p	Y,(ramBME280_rawPRESSURE)	; load --> (raw_PRESSURE)
		ld		r16,Y+					
		ld		r17,Y+				
		ld		r18,Y+				
		clr		r19
		sbrc	r18,7
		ser		r19	
		ldi		r20,BYTE1(0x100000)		; r20 = A.0
		ldi		r21,BYTE2(0x100000)		; r21 = A.1
		ldi		r22,BYTE3(0x100000)		; r22 = A.2
		clr		r23
		sub		r20,r16
		sbc		r21,r17
		sbc		r22,r18
		sbc		r23,r19

; Rechnung:		(Term2) = ((var2)>>12)			>>8 and >>4
;================================================================================================================
		load_p	Y,(ramBME280_var2)		; load --> (var2)
		ld		r19,Y+	; Dummy load	; r16 = B.0	
		ld		r16,Y+					; r17 = B.1
		ld		r17,Y+					; r18 = B.2
		ld		r18,Y+					; r19 = B.3
		clr		r19
		sbrc	r18,7
		ser		r19			; add new MSB with correct signed
		asr		r19
		ror		r18
		ror		r17
		ror		r16			; >>1	--> /2		1 times shift right
		asr		r19
		ror		r18
		ror		r17
		ror		r16			; >>1	--> /4		2 times shift right
		asr		r19
		ror		r18
		ror		r17
		ror		r16			; >>1	--> /8		3 times shift right
		asr		r19
		ror		r18
		ror		r17
		ror		r16			; >>1	--> /16		4 times shift right

; Rechnung:		(Term3) = ((Term1) - (Term2))		(Term3) -> unsigned!!!!
;================================================================================================================
		sub		r20,r16
		sbc		r21,r17
		sbc		r22,r18
		sbc		r23,r19

; Rechnung:		(p) = (Term3) * 3125
;================================================================================================================
		ldi		r16,BYTE1(3125)
		ldi		r17,BYTE2(3125)
		rcall	muls_32x16			; eventuell unsigned mul
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_p)	; store --> [p]
		st		Y+,r2
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[p]%%

; 9.)10.) Case		IF (p < (0x80000000))	-->  9.)	-> positiv
;									ELSE	--> 10.)	-> negativ
;================================================================================================================
		ldi		r20,BYTE1(0x80000000)
		ldi		r21,BYTE2(0x80000000)
		ldi		r22,BYTE3(0x80000000)
		ldi		r23,BYTE4(0x80000000)

		load_p	Y,(ramBME280_var1)		; load -->	(var1)
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		ld		r18,Y+					; r18 = B.2
		ld		r19,Y+					; r19 = B.3
		cp		r2,r20
		cpc		r3,r21
		cpc		r4,r22
		cpc		r5,r23					; COMPARE [p] , [0x 80'00'00'00]
		movw	r20,r2
		movw	r22,r4
		brsh	bme280_p_negativ

; 9.) Case	--> positiv ((p) < 0x80000000)
; Rechnung		(p) = ((p)<<1) / var1					[var1] -> unsigned
;================================================================================================================
bme280_p_positiv:
		lsl		r20					; r23:r20 -> [p]
		rol		r21
		rol		r22
		rol		r23					; <<1	--> *2		1 times shift left
		rcall	rdiv_u32_u32
		rjmp	bme280_next_calc

; 10.) Case	--> negativ ((p) >= 0x80000000)
; Rechnung		(p) = ( (p) / (var1) )<<1
;================================================================================================================
bme280_p_negativ:
		rcall	rdiv_u32_u32
		lsl		r2
		rol		r3
		rol		r4
		rol		r5

bme280_next_calc:
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_p)	; store --> [p] 
		st		Y+,r2
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[p]%%

; 11.) Berechnung 		((var1)NEU) = (dig_P9) * ( ((p)>>3) * ((p)>>3) )		
; Rechnung	(Term1) = ((p)>>3)
;================================================================================================================
		asr		r5
		ror		r4
		ror		r3
		ror		r2			; >>1	--> /2		1 times shift right
		asr		r5
		ror		r4
		ror		r3
		ror		r2			; >>1	--> /4		2 times shift right
		asr		r5
		ror		r4
		ror		r3
		ror		r2			; >>1	--> /8		3 times shift right

; Rechnung	(Term2) = (Term1) * (Term1)
;================================================================================================================
		movw	r20,r2
		movw	r22,r4
		movw	r16,r2
		movw	r18,r4
		rcall	muls_32x32

; Rechnung	(Term3) = (Term2)>>13	--> new cleared lowest Byte ->(>>8)		reminde >>5  or shift 3 times <<3
;================================================================================================================
		clr		r6
		sbrc	r5,7
		com		r6
		mov		r7,r6
		lsl		r3
		rol		r4
		rol		r5
		rol		r6
		rol		r7			; <<1	--> *2		1 times shift left
		lsl		r3
		rol		r4
		rol		r5
		rol		r6
		rol		r7			; <<1	--> *4		2 times shift left
		lsl		r3
		rol		r4
		rol		r5
		rol		r6
		rol		r7			; <<1	--> *8		3 times shift left

; Rechnung	(Term4) = (dig_9) * (Term3)
;================================================================================================================
		load_p	Y,(ramBME280_DIG_P9)	; load --> dig_P9
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		movw	r20,r4					; r21:r20 = A.1:A.0
		movw	r22,r6					; r23:r22 = A.3:A.2
		rcall	muls_32x16

; Rechnung	((var1)NEU) = (Term4)>>12					>>8 and >>4
;================================================================================================================
		asr		r5
		ror		r4
		ror		r3			; >>1	--> /2		1 times shift right
		asr		r5
		ror		r4
		ror		r3			; >>1	--> /4		2 times shift right
		asr		r5
		ror		r4
		ror		r3			; >>1	--> /8		3 times shift right
		asr		r5
		ror		r4
		ror		r3			; >>1	--> /16		4 times shift right
		clr		r23
		sbrc	r5,7
		ser		r23
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var1)			; store --> [var1]
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
		st		Y+,r23
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var1]%%

; 12.) Berechnung		((var2)NEU) = ( ( ((p)>>2) * (dig_P8) )>>13		
; Rechnung	(Term1) = ((p)>>2)
;================================================================================================================
		load_p	Y,(ramBME280_p)			; load --> [p]
		ld		r20,Y+					; r20 = A.0
		ld		r21,Y+					; r21 = A.1
		ld		r22,Y+					; r22 = A.2
		ld		r23,Y+					; r23 = A.3
		asr		r23
		ror		r22
		ror		r21
		ror		r20			; >>1	--> /2		1 times shift right
		asr		r23
		ror		r22
		ror		r21
		ror		r20			; >>1	--> /4		2 times shift right

; Rechnung	(Term2) = (Term1) * (dig_P8)
;================================================================================================================
		load_p	Y,(ramBME280_DIG_P8)	; load --> [dig_P8]
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		rcall	muls_32x16

; Rechnung	((var2)NEU) = (Term2)>>13	
;									--> new cleared lowest Byte ->(>>8)		reminde >>5  or shift 3 times <<3
;================================================================================================================
		lsl		r3
		rol		r4
		rol		r5
		rol		r6
		rol		r7			; <<1	--> *2		1 times shift left
		lsl		r3
		rol		r4
		rol		r5
		rol		r6
		rol		r7			; <<1	--> *4		2 times shift left
		lsl		r3
		rol		r4
		rol		r5
		rol		r6
		rol		r7			; <<1	--> *8		3 times shift left

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var2)			; store --> [var2]
		st		Y+,r4
		st		Y+,r5
		st		Y+,r6
		st		Y+,r7
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var2]%%

; 13.) Berechnung 		(PRESSURE) = ( ((var1) + (var2) + (dig_P7)) >>4)		
; Rechnung	(Term1) = (var1) + (var2)
;================================================================================================================
		load_p	Y,(ramBME280_var1)		; load --> [var1]
		ld		r20,Y+					; r20 = B.0
		ld		r21,Y+					; r21 = B.1
		ld		r22,Y+					; r22 = B.2
		ld		r23,Y+					; r23 = B.3
		add		r20,r4
		adc		r21,r5
		adc		r22,r6
		adc		r23,r7

; Rechnung	(Term2) = (Term1) + (dig_P7)
;================================================================================================================
		load_p	Y,(ramBME280_DIG_P7)	; load --> dig_P7
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		add		r20,r16
		adc		r21,r17
		adc		r22,zero
		adc		r23,zero

; Rechnung	(Term3) = (Term2)>>4
;================================================================================================================
		asr		r23
		ror		r22
		ror		r21
		ror		r20			; >>1	--> /2		1 times shift right
		asr		r23
		ror		r22
		ror		r21
		ror		r20			; >>1	--> /4		2 times shift right
		asr		r23
		ror		r22
		ror		r21
		ror		r20			; >>1	--> /8		3 times shift right
		asr		r23
		ror		r22
		ror		r21
		ror		r20			; >>1	--> /16		4 times shift right

; Rechnung	(PRESSURE) = (p) + (Term3)
;================================================================================================================
		load_p	Y,(ramBME280_p)			; load --> [p]
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		ld		r18,Y+					; r18 = B.2
		ld		r19,Y+					; r19 = B.3
		add		r20,r16
		adc		r21,r17
		adc		r22,r18
		adc		r23,r19
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

		subi	r20,BYTE1(-800)
		sbci	r21,BYTE2(-800)
		sbci	r22,BYTE3(-800)
		sbci	r23,BYTE4(-800)

;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_PRESSURE); store --> [PRESSURE]
		st		Y+,r20
		st		Y+,r21
		st		Y+,r22
		st		Y+,r23
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[PRESSURE]%%

		ret


;###############################################################################################################
;***************************************************************************************************************
 bme280_calc_humidity:		; Berechnung Luftdruck
; 1.) Berechnung 		(var_1) = ( ((T_fine) - 76800)
;================================================================================================================
		load_p	Y,(ramBME280_T_fine)	; load --> [T_fine]
		ld		r20,Y+					; r20 = B.0
		ld		r21,Y+					; r21 = B.1
		ld		r22,Y+					; r22 = B.2
		ld		r23,Y+					; r23 = B.3
		subi	r20,BYTE1(76800)
		sbci	r21,BYTE2(76800)
		sbci	r22,BYTE3(76800)
		sbci	r23,BYTE4(76800)
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var1)		; store --> [var1]
		st		Y+,r20
		st		Y+,r21
		st		Y+,r22
		st		Y+,r23
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var1]%%

; 2.) Berechnung 		((var_1)NEU) = (var2) * (var3)
;		(var2) = ((((adc_H << 14) - (((int32_t)dig_H4) << 20) - (((int32_t)dig_H5) * v_x1_u32r)) + ((int32_t)16384)) >> 15)
;		(var3) = (((((((v_x1_u32r * ((int32_t)dig_H6)) >> 10) * (((v_x1_u32r *	((int32_t)dig_H3)) >> 11) + ((int32_t)32768))) >> 10) + ((int32_t)2097152)) * ((int32_t)dig_H2) + 8192) >> 14)
;================================================================================================================

; Rechnung:	(var2)
; Rechnung: (Term3)	= (dig_H5) * (var1)
;================================================================================================================
		load_p	Y,(ramBME280_var1)		; load --> var1
		ld		r20,Y+					; r20 = A.0
		ld		r21,Y+					; r21 = A.1
		ld		r22,Y+					; r22 = A.2
		ld		r23,Y+					; r23 = A.3
		load_p	Y,(ramBME280_DIG_H5)	; load --> dig_H5
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		rcall	muls_32x16
;		(Term3) = r5:r2

; Rechnung:	(var2)
; Rechnung: (Term2)	= (dig_H4)<<20			>>4 shift 4 times right    AND    <<16 (fill in 2 new register at LSB)
;================================================================================================================
		load_p	Y,(ramBME280_DIG_H4)	; load --> dig_H4
		ld		r19,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		clr		r18
		asr		r17
		ror		r19
		ror		r18						; >>1	--> /2		1 times shift right
		asr		r17
		ror		r19
		ror		r18						; >>1	--> /4		2 times shift right
		asr		r17
		ror		r19
		ror		r18						; >>1	--> /8		3 times shift right
		asr		r17
		ror		r19
		ror		r18						; >>1	--> /16		4 times shift right
;		(Term2) = r19:r16

; Rechnung:	(var2)
; Rechnung: (Term1)	= (adc_H)<<14			<<16 (fill in 2 new register at LSB)    AND   >>2 shift 2 times right 
;================================================================================================================
		load_p	Y,(ramBME280_rawHUMIDITY); load --> (rawHUMIDITY)
		ld		r22,Y+					; r20 = A.0
		ld		r23,Y+					; r21 = A.1
		clr		r20
		clr		r21
		asr		r23
		ror		r22
		ror		r21						; >>1	--> /2		1 times shift right
		asr		r23
		ror		r22
		ror		r21						; >>1	--> /4		2 times shift right
;		(Term3) = r5:r2
;		(Term2) = r19:r16
;		(Term1) = r23:r20

; Rechnung:	(var2)
; Rechnung: (Term4)	= (Term1 )- (Term2) - (Term3)
;================================================================================================================
		sub		r20,zero		; r16 = 0
		sbc		r21,zero		; r17 = 0
		sbc		r22,r18
		sbc		r23,r19
		sub		r20,r2
		sbc		r21,r3
		sbc		r22,r4
		sbc		r23,r5
;		(Term4) = r23:r20

; Rechnung:	(var2)
; Rechnung: (Term5)	= (Term4) + 16384
;================================================================================================================
		subi	r20,BYTE1(-16384)
		sbci	r21,BYTE2(-16384)
		sbci	r22,BYTE3(-16384)
		sbci	r23,BYTE4(-16384)
;		(Term5)	= r23:r20

; Rechnung:	(var2)
; Rechnung: (var2)	= (Term5) >>15
;================================================================================================================
		clr		r20
		sbrc	r23,7
		ser		r20						; --> A.2
		mov		r6,r20					; --> A.3
		lsl		r21
		rol		r22						; --> A.0
		rol		r23						; --> A.1
		rol		r20						; <<1	--> *2		1 times shift left	
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var2)		; store --> [var2]
		st		Y+,r22
		st		Y+,r23
		st		Y+,r20
		st		Y+,r6
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var2]%%

; Rechnung:	(var3)
; Rechnung: (Term1)	= (((var1) * (dig_H3)
;================================================================================================================
		load_p	Y,(ramBME280_var1)		; load --> var1
		ld		r20,Y+					; r20 = A.0
		ld		r21,Y+					; r21 = A.1
		ld		r22,Y+					; r22 = A.2
		ld		r23,Y+					; r23 = A.3
		load_p	Y,(ramBME280_DIG_H3)	; load --> dig_H3
		ld		r16,Y+					; r16 = B.0
		rcall	mulsu_32x8				; Result: r6:r2
;		(Term1) = r5:r2

; Rechnung:	(var3)
; Rechnung: (Term2)	= (Term1)>>11
;================================================================================================================
		asr		r6
		ror		r5
		ror		r4
		ror		r3						; >>1	--> /2		1 times shift right
		asr		r6
		ror		r5
		ror		r4
		ror		r3						; >>1	--> /4		2 times shift right
		asr		r6
		ror		r5
		ror		r4
		ror		r3						; >>1	--> /8		3 times shift right
;		(Term2) = r6:r3

; Rechnung:	(var3)
; Rechnung: (Term3)	= (Term2) + 32768
;================================================================================================================
		ldi		r16,BYTE1(32768)
		ldi		r17,BYTE2(32768)
		add		r3,r16
		adc		r4,r17
		adc		r5,zero
		adc		r6,zero
;		(Term3) = r6:r3 ---> cache in var3
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var3)	; cache store --> [var3]
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
		st		Y+,r6
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var3]%%

; Rechnung:	(var3)
; Rechnung: (Term4)	= (var1) * (dig_H6)	
;================================================================================================================
		load_p	Y,(ramBME280_var1)		; load --> var1
		ld		r20,Y+					; r20 = A.0
		ld		r21,Y+					; r21 = A.1
		ld		r22,Y+					; r22 = A.2
		ld		r23,Y+					; r23 = A.3
		load_p	Y,(ramBME280_DIG_H6)	; load --> dig_H6
		ld		r16,Y+					; r16 = B.0
		rcall	muls_32x8				; Result: r6:r2
;		(Term4) = r5:r2

; Rechnung:	(var3)
; Rechnung: (Term5)	= (Term4)>>10
;================================================================================================================
		asr		r6
		ror		r5
		ror		r4
		ror		r3						; >>1	--> /2		1 times shift right
		asr		r6
		ror		r5
		ror		r4
		ror		r3						; >>1	--> /4		2 times shift right
;		(Term5) = r6:r3

; Rechnung:	(var3)
; Rechnung: (Term6)	= (Term5) * (Term3)
;================================================================================================================
		mov		r20,r3
		mov		r21,r4
		mov		r22,r5
		mov		r23,r6
		load_p	Y,(ramBME280_var3)		; load --> var3
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		ld		r18,Y+					; r18 = B.2
		ld		r19,Y+					; r19 = B.3
		rcall	muls_32x32				; Result: r9:r2
;		(Term6) = r9:r2

; Rechnung:	(var3)
; Rechnung: (Term7)	= (Term6)>>10
;================================================================================================================
		asr		r9
		ror		r8
		ror		r7
		ror		r6
		ror		r5
		ror		r4
		ror		r3						; >>1	--> /2		1 times shift right
		asr		r9
		ror		r8
		ror		r7
		ror		r6
		ror		r5
		ror		r4
		ror		r3						; >>1	--> /4		2 times shift right
;		(Term7) = r9:r3

; Rechnung:	(var3)
; Rechnung: (Term8)	= (Term7) + 2097152
;================================================================================================================
		mov		r20,r3
		mov		r21,r4
		mov		r22,r5
		mov		r23,r6
		subi	r20,BYTE1(-2097152)
		sbci	r21,BYTE2(-2097152)
		sbci	r22,BYTE3(-2097152)
		sbci	r23,BYTE4(-2097152)
;		(Term8) = r23:r20

; Rechnung:	(var3)
; Rechnung: (Term9)	= (Term8) * (dig_H2)
;================================================================================================================
		load_p	Y,(ramBME280_DIG_H2)	; load --> dig_H2
		ld		r16,Y+					; r16 = B.0
		ld		r17,Y+					; r17 = B.1
		rcall	muls_32x16				; Result: r7:r2
;		(Term9) = r7:r2

; Rechnung:	(var3)
; Rechnung: (Term10) = (Term9) + 8192
;================================================================================================================
		movw	r16,r2
		movw	r18,r4
		movw	r20,r6
		subi	r16,BYTE1(-8192)
		sbci	r17,BYTE2(-8192)
		sbci	r18,(0xFF)
		sbci	r19,(0xFF)
		sbci	r20,(0xFF)
		sbci	r21,(0xFF)		
;		(Term10) = r21:r16

; Rechnung:	(var3)
; Rechnung: (var3) = (Term10)>>14
;================================================================================================================
		lsl		r17
		rol		r18
		rol		r19
		rol		r20
		rol		r21						; <<1	--> *2		1 times shift left
		lsl		r17
		rol		r18
		rol		r19
		rol		r20
		rol		r21						; <<1	--> *4		2 times shift left
		movw	r16,r18
		movw	r18,r20
;		(var3) = r19:r16 
/*
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
		load_p	Y,(ramBME280_var3)	; store --> [var3]
		st		Y+,r16
		st		Y+,r17
		st		Y+,r18
		st		Y+,r19
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var3]%%
*/
; Rechnung:	((var1)NEU)
; Rechnung: ((var1)NEU) = (var2) * (var3)
;================================================================================================================
		load_p	Y,(ramBME280_var2)		; load --> var2
		ld		r20,Y+					; r20 = B.0
		ld		r21,Y+					; r21 = B.1
		ld		r22,Y+					; r22 = B.2
		ld		r23,Y+					; r23 = B.3
		rcall	muls_32x32
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var1)	; store --> [var1]
		st		Y+,r2
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var1]%%

; 3.) Berechnung 		((var_1)NEU) = (var1 - (((((var1 >> 15) * (var1 >> 15)) >> 7) * ((int32_t)dig_H1)) >> 4))
; Rechnung:	(Term1) = (var1)>>15
;================================================================================================================
		lsl		r3
		rol		r4
		rol		r5
		rol		r6
		rol		r7						; <<1	--> *2		1 times shift left
;		(Term1) = r7:r4		
			
; Rechnung:	(Term2) = (Term1) * (Term1)
;================================================================================================================
		movw	r20,r4
		movw	r22,r6
		movw	r16,r4
		movw	r18,r6
		rcall	muls_32x32
;		(Term2) = r9:r2		

; Rechnung:	(Term3) = (Term2)>>7
;================================================================================================================
		lsl		r2
		rol		r3
		rol		r4
		rol		r5
		rol		r6
;		(Term3) = r9:r3		

; Rechnung:	(Term4) = (Term3) * (dig_H1)		signed x unsigned
;================================================================================================================
		mov		r20,r3
		mov		r21,r4
		mov		r22,r5
		mov		r23,r6
		load_p	Y,(ramBME280_DIG_H1)	; load --> dig_H2
		ld		r16,Y+					; r16 = B.0
		rcall	mulsu_32x8				; Result: r6:r2
;		(Term4) = r6:r2		

; Rechnung:	(Term5) = (Term4)>>4
;================================================================================================================
		asr		r6
		ror		r5
		ror		r4
		ror		r3
		ror		r2				; >>1	--> /2		1 times shift right
		asr		r6
		ror		r5
		ror		r4
		ror		r3
		ror		r2				; >>1	--> /4		2 times shift right
		asr		r6
		ror		r5
		ror		r4
		ror		r3
		ror		r2				; >>1	--> /8		3 times shift right
		asr		r6
		ror		r5
		ror		r4
		ror		r3
		ror		r2				; >>1	--> /16		4 times shift right
;		(Term5) = r6:r2		

; Rechnung:	(var1)NEU) = (var1) - (Term5)
;================================================================================================================
		load_p	Y,(ramBME280_var1)		; load --> var1
		ld		r20,Y+					; r20 = A.0
		ld		r21,Y+					; r21 = A.1
		ld		r22,Y+					; r22 = A.2
		ld		r23,Y+					; r23 = A.3
		sub		r20,r2
		sbc		r21,r3
		sbc		r22,r4
		sbc		r23,r5
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_var1)	; store --> [var1]
		st		Y+,r20
		st		Y+,r21
		st		Y+,r22
		st		Y+,r23
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[var1]%%

; 4.) Berechnung 			if		(var1 < 0)	than ((var_1)NEU) = 0					--> min begrenzen
;												else ((var_1)NEU) = (var1)
;================================================================================================================
bme280_calc_humidity_limit_min:
		cp		r20,zero
		cpc		r21,zero
		cpc		r22,zero
		cpc		r23,zero
		brge	bme280_calc_humidity_limit_max
		clr		r20
		clr		r21
		movw	r22,r20

; 5.) Berechnung 		if (var1 > 419430400)	than ((var_1)NEU) = 419430400			--> max begrenzen
;												else ((var_1)NEU) = (var1)
;================================================================================================================
bme280_calc_humidity_limit_max:
		ldi		r16,BYTE1(0x19000000)
		ldi		r17,BYTE2(0x19000000)
		ldi		r18,BYTE3(0x19000000)
		ldi		r19,BYTE4(0x19000000)
		cp		r20,r16
		cpc		r21,r17
		cpc		r22,r18
		cpc		r23,r19
		brlt	bme280_calc_humidity_limit_ok
		movw	r20,r16
		movw	r22,r18

; 6.) Berechnung 		(HUMIDITY) = (var1)>>12
;================================================================================================================
bme280_calc_humidity_limit_ok:
		asr		r23
		ror		r22
		ror		r21				; >>1	--> /2		1 times shift right
		asr		r23
		ror		r22
		ror		r21				; >>1	--> /4		1 times shift right
		asr		r23
		ror		r22
		ror		r21				; >>1	--> /8		1 times shift right
		asr		r23
		ror		r22
		ror		r21				; >>1	--> /16		1 times shift right
		clr		r16
		sbrc	r23,7
		ser		r16
		mov		r20,r21
		mov		r21,r22
		mov		r22,r23
		mov		r23,r16
		ldi		r16,BYTE1(1000)
		ldi		r17,BYTE2(1000)
		rcall	muls_32x16
		asr		r6
		ror		r5
		ror		r4
		ror		r3				; >>1	--> /2		1 times shift right
		asr		r6
		ror		r5
		ror		r4
		ror		r3				; >>1	--> /4		2 times shift right		
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		load_p	Y,(ramBME280_HUMIDITY)	; store --> [HUMIDITY]
		st		Y+,r3
		st		Y+,r4
		st		Y+,r5
		st		Y+,r6
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%[HUMIDITY]%%

		ret



