//----------------------------------------------------------------------
//     DELAY's @16Mhz
//----------------------------------------------------------------------

;--- Konstanten --------------------------------------------------------

.equ    CYCLES_PER_MS   = ((F_CPU)/1000)
.equ    CYCLES_PER_US   = ((F_CPU)/1000000)

;*************************** wartet ca. 1ms *******************************
; Sub: Wartet ca. 1ms
; Parameter:	-
; Return:		-
; Scratch-Reg:	-
;***************************************************************************

.macro  delayms                    ; ldt 16Bit @1 nach @0 High und @0 Low
        ldi     r25,HIGH(@0)
        ldi     r24,LOW(@0)
		rcall	delay_ms
.endmacro

.macro  delayus                    ; ldt 16Bit @1 nach @0 High und @0 Low
        ldi     r25,HIGH(@0)
        ldi     r24,LOW(@0)
		rcall	delay_us
.endmacro

delay_ms: // r24:r25
		rcall	wait1ms
		sbiw	r24,1
		brne	delay_ms
		ret

delay_us: // r24:r25
		rcall	wait1us
		sbiw	r24,1
		brne	delay_us
		ret

wait1ms:
		push	XH
		push	XL
		ldi		XH,high((CYCLES_PER_MS)/4)			; 4 Anzahl der Zyklen fr die Schleife
		ldi		XL,low((CYCLES_PER_MS)/4)
wait1msloop:
		sbiw	X,1
		brne	wait1msloop
		pop		XL
		pop		XH
		ret

waitXms:
		rcall	wait1ms
		dec		r16
		brne	waitXms
		ret

waitXus:
		rcall	wait1us
		dec		r16
		brne	waitXus
		ret

wait1us:		; @ 16Mhz
;		lpm		
		lpm		
		lpm		
		ret
