;************************************************************************
;*																		*
;*			unsigned rounded division 32 bit							*
;*																		*
;*				IN			IN			OUT			Reminde				*
;*			   R23:R20	/  R19:R16  =   R5:R2		R9:R6				*
;*				A3:A0   /   B3:B0   =   T3:T0		T7:T4				*
;*																		*
;************************************************************************

; T0..T3 = A0..A3 / B0..B3
; T4..T7 = remainde

rdiv_u32_u32:
		load_p	Y,(ramBUFFER_A)		; Copy INPUT VAR	
		st		Y+,R16			; B.0
		st		Y+,R17			; B.1
		st		Y+,R18			; B.2
		st		Y+,R19			; B.3
		st		Y+,R20			; A.0
		st		Y+,R21			; A.1
		st		Y+,R22			; A.2
		st		Y+,R23			; A.3
		st		Y+,R24			; TEMPORARY

		mov		R2, R16			;T = B
		mov		R3, R17
		mov		R4, R18
		mov		R5, R19
		lsr		R5				;B / 2
		ror		R4
		ror		R3
		ror		R2
		add		R20, R2			;A = A + B / 2
		adc		R21, R3
		adc		R22, R4
		adc		R23, R5
		rjmp	rdiv_u32_u32_next
;************************************************************************
;*																		*
;*					unsigned division 32 bit							*
;*																		*
;*				IN			IN			OUT			Reminde				*
;*			   R23:R20	/  R19:R16  =   R5:R2		R9:R6				*
;*				A3:A0   /   B3:B0   =   T3:T0		T7:T4				*
;*																		*
;************************************************************************
;cycle: max 684

; T0..T3 = A0..A3 / B0..B3
; T4..T7 = remainde

div_u32_u32:
		load_p	Y,(ramBUFFER_A)		; Copy INPUT VAR	
		st		Y+,R16			; B.0
		st		Y+,R17			; B.1
		st		Y+,R18			; B.2
		st		Y+,R19			; B.3
		st		Y+,R20			; A.0
		st		Y+,R21			; A.1
		st		Y+,R22			; A.2
		st		Y+,R23			; A.3
		st		Y+,R24			; TEMPORARY
rdiv_u32_u32_next:
		clr		R2
		clr		R3
		clr		R4
		clr		R5
		ldi		R24, 32
div_u32_u32_1:
		lsl		R20
		rol		R21
		rol		R22
		rol		R23
		rol		R2
		rol		R3
		rol		R4
		rol		R5
		cp		R2, R16
		cpc		R3, R17
		cpc		R4, R18
		cpc		R5, R19
		brcs	div_u32_u32_2
		sub		R2, R16
		sbc		R3, R17
		sbc		R4, R18
		sbc		R5, R19
		inc		R20
div_u32_u32_2:	
		dec		R24
		brne	div_u32_u32_1
		movw	r6,r2
		movw	r8,r4
		movw	r2,r20
		movw	r4,r22
		load_p	Y,(ramBUFFER_A)		; Copy INPUT VAR	
		ld		R16,Y+			; TEMPORARY
		ld		R17,Y+			; A.3
		ld		R18,Y+			; A.2
		ld		R19,Y+			; A.1
		ld		R20,Y+			; A.0
		ld		R21,Y+			; B.3
		ld		R22,Y+			; B.2
		ld		R23,Y+			; B.1
		ld		R24,Y+			; B.0
		ret
