


;.equ	BME280_ADDR					= 0x76
;.equ	BME280_ADDR2				= 0x78
;.equ	I2C_ADDR = BME280_ADDR	

.equ	regBME280_DIG_T1			= 0x88
.equ	regBME280_DIG_T2			= 0x8A
.equ	regBME280_DIG_T3			= 0x8C
.equ	regBME280_DIG_P1			= 0x8E
.equ	regBME280_DIG_P2			= 0x90
.equ	regBME280_DIG_P3			= 0x92
.equ	regBME280_DIG_P4			= 0x94
.equ	regBME280_DIG_P5			= 0x96
.equ	regBME280_DIG_P6			= 0x98
.equ	regBME280_DIG_P7			= 0x9A
.equ	regBME280_DIG_P8			= 0x9C
.equ	regBME280_DIG_P9			= 0x9E
.equ	regBME280_DIG_H1			= 0xA1
.equ	regBME280_ID				= 0xD0
.equ	regBME280_RESET				= 0xE0
.equ	regBME280_DIG_H2			= 0xE1
.equ	regBME280_DIG_H3			= 0xE3
.equ	regBME280_DIG_H4			= 0xE4
.equ	regBME280_DIG_H5			= 0xE5
.equ	regBME280_DIG_H6			= 0xE7
.equ	regBME280_CTRL_HUM			= 0xF2
.equ	regBME280_STATUS			= 0xF3
.equ	regBME280_CTRL_MEAS			= 0xF4
.equ	regBME280_CONFIG			= 0xF5
.equ	regBME280_PRESSURE			= 0xF7		; MSB/LSB/XSLB
.equ	regBME280_TEMP				= 0xFA		; MSB/LSB/XLSB
.equ	regBME280_HUM				= 0xFD		; MSB/LSB


; regBME280_RESET [0xE0]
.equ	dataRESET					= 0xB6			; RESET-Word

; regBME280_CTRL_HUM [0xF2]			; control oversampling of humidity data
.equ	bme280_osrs_h_skipped		= 0x00<<0		; oversampling humidity skipped (output set to 0x8000)
.equ	bme280_osrs_h_x1			= 0x01<<0		; oversampling x1
.equ	bme280_osrs_h_x2			= 0x02<<0		; oversampling x2
.equ	bme280_osrs_h_x4			= 0x03<<0		; oversampling x4
.equ	bme280_osrs_h_x8			= 0x04<<0		; oversampling x8
.equ	bme280_osrs_h_x16			= 0x05<<0		; oversampling x16

; regBME280_STATUS [0xF3]			; indicate status of device
.equ	bme280_im_update_bp			= 0				; only RD	set '1' if data just copied in image reg | '0' if done
.equ	bme280_measuring_bp			= 3				; only RD	set '1' if conversation is running

; regBME280_CTRL_MEAS [0xF4]		; control oversampling of pressure & temperatur data and mode of device
; control oversampling of temperatur data
.equ	bme280_osrs_t_skipped		= 0x00<<5		; oversampling temperatur skipped (output set to 0x80000)
.equ	bme280_osrs_t_x1			= 0x01<<5		; oversampling temperatur x1
.equ	bme280_osrs_t_x2			= 0x02<<5		; oversampling temperatur x2
.equ	bme280_osrs_t_x4			= 0x03<<5		; oversampling temperatur x4
.equ	bme280_osrs_t_x8			= 0x04<<5		; oversampling temperatur x8
.equ	bme280_osrs_t_x16			= 0x05<<5		; oversampling temperatur x16
; control oversampling of pressure data
.equ	bme280_osrs_p_skipped		= 0x00<<2		; oversampling pressure skipped (output set to 0x80000)
.equ	bme280_osrs_p_x1			= 0x01<<2		; oversampling pressure x1
.equ	bme280_osrs_p_x2			= 0x02<<2		; oversampling pressure x2
.equ	bme280_osrs_p_x4			= 0x03<<2		; oversampling pressure x4
.equ	bme280_osrs_p_x8			= 0x04<<2		; oversampling pressure x8
.equ	bme280_osrs_p_x16			= 0x05<<2		; oversampling pressure x16
; control sensor mode of device
.equ	bme280_sleep_mode			= 0x00<<0		; sleep mode
.equ	bme280_forced_mode			= 0x01<<0		; forced mode
.equ	bme280_normal_mode			= 0x02<<0		; normal mode

; regBME280_CONFIG [0xF5]			; sets the rate | filter | interface options
.equ	bme280_spi3w_bp				= 0				; [0] = disable		[1] = enable
; controls the time constant of IIR filter
.equ	bme280_filter_off			= 0x00<<2		; time constant of IIR filter off
.equ	bme280_filter_x2			= 0x01<<2		; time constant of IIR filter x1
.equ	bme280_filter_x4			= 0x02<<2		; time constant of IIR filter x4
.equ	bme280_filter_x8			= 0x03<<2		; time constant of IIR filter x8
.equ	bme280_filter_x16			= 0x04<<2		; time constant of IIR filter x16
; controls inactive duration in normal mode
.equ	bme280_t_sb_500us			= 0x00<<5		; t_standby =    0.5 ms
.equ	bme280_t_sb_62ms			= 0x01<<5		; t_standby =   62.5 ms
.equ	bme280_t_sb_125ms			= 0x02<<5		; t_standby =    125 ms
.equ	bme280_t_sb_250ms			= 0x03<<5		; t_standby =    250 ms
.equ	bme280_t_sb_500ms			= 0x04<<5		; t_standby =    500 ms
.equ	bme280_t_sb_1000ms			= 0x05<<5		; t_standby =   1000 ms
.equ	bme280_t_sb_10ms			= 0x06<<5		; t_standby =     10 ms
.equ	bme280_t_sb_20ms			= 0x07<<5		; t_standby =     20 ms

/*
.dseg
ramBME280_DIG_T1:		.BYTE 2			; unsigned short	constante
ramBME280_DIG_T2:		.BYTE 2			; signed short		constante
ramBME280_DIG_T3:		.BYTE 2			; signed short		constante
ramBME280_DIG_P1:		.BYTE 2			; unsigned short	constante
ramBME280_DIG_P2:		.BYTE 2			; signed short		constante
ramBME280_DIG_P3:		.BYTE 2			; signed short		constante
ramBME280_DIG_P4:		.BYTE 2			; signed short		constante
ramBME280_DIG_P5:		.BYTE 2			; signed short		constante
ramBME280_DIG_P6:		.BYTE 2			; signed short		constante
ramBME280_DIG_P7:		.BYTE 2			; signed short		constante
ramBME280_DIG_P8:		.BYTE 2			; signed short		constante
ramBME280_DIG_P9:		.BYTE 2			; signed short		constante
ramBME280_DIG_H1:		.BYTE 1			; unsigned char		constante
ramBME280_DIG_H2:		.BYTE 2			; signed short		constante
ramBME280_DIG_H3:		.BYTE 1			; unsigned char		constante
ramBME280_DIG_H4:		.BYTE 2			; signed short		constante
ramBME280_DIG_H5:		.BYTE 2			; signed short		constante
ramBME280_DIG_H6:		.BYTE 1			; signed char		constante
ramBME280_ID:			.BYTE 1			; unsigned char		identify
ramBME280_rawPRESSURE:	.BYTE 3			; unsigned 24bit	RAW messurement [20bit]
ramBME280_rawTEMP:		.BYTE 3			; unsigned 24bit	RAW messurement [20bit]
ramBME280_rawHUMIDITY:	.BYTE 2			; unsigned 16bit	RAW messurement [16bit]
ramBME280_T_fine:		.BYTE 4
ramBME280_TEMP:			.BYTE 4
ramBME280_PRESSURE:		.BYTE 4
ramBME280_HUMIDITY:		.BYTE 4
ramBME280_p:			.BYTE 4
ramBME280_var1:			.BYTE 4
ramBME280_var2:			.BYTE 4
ramBME280_var3:			.BYTE 4
ramBME280_var4:			.BYTE 4
ramBME280_var1_P2:		.BYTE 4
ramBUFFER_A:			.BYTE 20
;ramBUFFER_B:			.BYTE 20
ramBUFFER_C:			.BYTE 20
.cseg
*/
;------------------------------------------------------------------------------------------------------------------------------------------
init_bme280:
		rcall	bme280_read_id
		lds		r16,(ramBME280_ID)
		cpi		r16,(0x60)
		breq	bme280_init_settings
		ret
bme280_init_settings:
;-----------------------------------------------------------------------------------
; bme280 setting ctrl_hum
		ldi		r16,BME280_ADDR
		lsl		r16
		mov		i2c_addr,r16
		rcall	twi_send_wr_start
; twi_wr_data:
		ldi		r16,(regBME280_ctrl_hum)
		rcall	twi_write
; twi_wr_data:
		ldi		r16,(bme280_osrs_h)
		rcall	twi_write
;-----------------------------------------------------------------------------------
; bme280 setting config
; twi_wr_data:
		ldi		r16,(regBME280_config)
		rcall	twi_write
; twi_wr_data:
		ldi		r16,(bme280_t_sb)|(bme280_filter)
		rcall	twi_write
;-----------------------------------------------------------------------------------
; bme280 setting ctrl_meas
; twi_wr_data:
		ldi		r16,(regBME280_ctrl_meas)
		rcall	twi_write
; twi_wr_data:
		ldi		r16,(bme280_osrs_t)|(bme280_osrs_p)|(bme280_mode)
		rcall	twi_write
		rcall	twi_send_stop
		ret
;------------------------------------------------------------------------------------------------------------------------------------------


bme280_read_id:
		ldi		r16,BME280_ADDR
		lsl		r16
		mov		i2c_addr,r16
		rcall	twi_send_wr_start
; twi_wr_data:
		ldi		r16,(regBME280_ID)
		rcall	twi_write
; twi_read_byte:
		rcall	twi_send_rd_start	
; twi_rd_data_store:
		rcall	twi_read_nack			; cause last byte (NACK) this function will send stop within
		sts		(ramBME280_ID),r17
		ret

;------------------------------------------------------------------------------------------------------------------------------------------
bme280_read_coefficients:
; read out dig_T1..dig_T3   und   dig_P1..dig_P9
		ldi		r16,BME280_ADDR
		lsl		r16
		mov		i2c_addr,r16
		rcall	twi_send_wr_start
; twi_wr_data:
		ldi		r17,24						; dig_T1..dig_T3   und   dig_P1..dig_P9
		load_p	Y,(ramBME280_DIG_T1)
		ldi		r16,(regBME280_DIG_T1)
		rcall	twi_read_bytes
; read out dig_H1
		ldi		r16,BME280_ADDR
		lsl		r16
		mov		i2c_addr,r16
		rcall	twi_send_wr_start
; twi_wr_data:
		ldi		r17,1						; dig_H1
		load_p	Y,(ramBME280_DIG_H1)
		ldi		r16,(regBME280_DIG_H1)
		rcall	twi_read_bytes

; read out dig_H2..dig_H7
		ldi		r16,BME280_ADDR
		lsl		r16
		mov		i2c_addr,r16
		rcall	twi_send_wr_start
; twi_wr_data:
		ldi		r17,7						; dig_H2..dig_H7
		load_p	Y,(ramBME280_DIG_H2)
		ldi		r16,(regBME280_DIG_H2)
		rcall	twi_read_bytes
; shift H4
		lds		r16,((ramBME280_DIG_H5)+1)	; (0xE7)
		sts		((ramBME280_DIG_H6)+0),r16
		lds		r16,((ramBME280_DIG_H4)+0)	; (0xE4)
		lds		r17,((ramBME280_DIG_H4)+1)	; (0xE5)
		mov		r18,r16						; make copy of r16	(0xE4)
		mov		r19,r17						; make copy of r17	(0xE5)
		andi	r19,0x0F
		swap	r18
		mov		r20,r18
		andi	r18,0xF0
		or		r18,r19						; r18 = new H4 [3:0]
		andi	r20,0x0F					; r20 = new H4 [11:4]
		sbrc	r20,3
		ori		r20,0xF0
		sts		((ramBME280_DIG_H4)+0),r18
		sts		((ramBME280_DIG_H4)+1),r20
; shift H5
		lds		r16,((ramBME280_DIG_H5)+0)	; (0xE6)
		mov		r18,r16						; make copy of r16 [0xE6]
		mov		r19,r17						; make copy of r17 (0xE5)
		swap	r19
		andi	r19,0x0F					; [3:0]
		swap	r18
		andi	r18,0xF0
		or		r18,r19						; r18 = new H5 [0:3]
		swap	r16
		andi	r16,0x0F					; r16 = new H5 [11:4]
		sbrc	r16,3
		ori		r16,0xF0
		sts		((ramBME280_DIG_H5)+0),r18
		sts		((ramBME280_DIG_H5)+1),r16
		ret
;------------------------------------------------------------------------------------------------------------------------------------------
bme280_forced_read_raw_data:
;------------------------------------------------------------------------------------------------------------------------------------------
;bme280_force_meassure:
; bme280 setting ctrl_meas
		ldi		r16,BME280_ADDR
		lsl		r16
		mov		i2c_addr,r16
		rcall	twi_send_wr_start
; twi_wr_data:
		ldi		r16,(regBME280_ctrl_meas)
		rcall	twi_write
; twi_wr_data:
		ldi		r16,(bme280_osrs_t)|(bme280_osrs_p)|(bme280_mode)
		rcall	twi_write
		rcall	twi_send_stop

;------------------------------------------------------------------------------------------------------------------------------------------
bme280_read_raw_data:
; get BME280 Status
		ldi		r16,BME280_ADDR
		lsl		r16
		mov		i2c_addr,r16
		rcall	twi_send_wr_start
; twi_wr_data:
		ldi		r16,(regBME280_STATUS)
		rcall	twi_write
; twi_read_byte:
		rcall	twi_send_rd_start		
; twi_rd_data_store:
		rcall	twi_read_nack					; read Byte in r17
		andi	r17,(1<<bme280_measuring_bp)|(1<<bme280_im_update_bp)
		tst		r17
		brne	bme280_read_raw_data


; read out raw_Temp, raw_Pressure, raw_Humidity
		rcall	twi_send_wr_start
; twi_wr_data:
		ldi		r17,8						; read	rawPressure [MSB|LSB|XLSB]  
		load_p	Y,(ramBME280_rawPRESSURE)	;		rawTemp		[MSB|LSB|XLSB] 
		ldi		r16,(regBME280_PRESSURE)	;		rawHumidity	[MSB|LSB]
		rcall	twi_read_bytes
; sort rawData
		load_p	Y,(ramBME280_rawPRESSURE)
;		lds		r16,((ramBUFFER)+0)			; MSB (7:0)
;		lds		r17,((ramBUFFER)+1)			; LSB (7:0)
;		lds		r18,((ramBUFFER)+2)			; XLSB (7:4)
		ld		r16,Y+			; rawPressure MSB  (7:0)
		ld		r17,Y+			; rawPressure LSB  (7:0)
		ld		r18,Y+			; rawPressure XLSB (7:4)
		swap	r18				; XLSB
		swap	r17				; LSB
		mov		r19,r17			; make copy of swaped r17	LSB
		andi	r18,0x0F
		andi	r17,0xF0
		or		r17,r18			; r17 = new XLSB + 1/2 LSB
		swap	r16				; MSB
		mov		r18,r16			; make copy of swaped r16	MSB
		andi	r19,0x0F
		andi	r16,0xF0
		or		r16,r19			; r16 = new 1/2 MSB + 1/2 LSB
		andi	r18,0x0F		; r18 = new 1/2 MSB
		sbiw	Y,3
		st		Y+,r17			; rawPressure XLSB (7:0)
		st		Y+,r16			; rawPressure LSB  (15:8)
		st		Y+,r18			; rawPressure MSB  (23:16)
		ld		r16,Y+			; rawTemp MSB  (7:0)
		ld		r17,Y+			; rawTemp LSB  (7:0)
		ld		r18,Y+			; rawTemp XLSB (7:4)
		swap	r18				; XLSB
		swap	r17				; LSB
		mov		r19,r17			; make copy of swaped r17	LSB
		andi	r18,0x0F
		andi	r17,0xF0
		or		r17,r18			; r17 = new XLSB + 1/2 LSB
		swap	r16				; MSB
		mov		r18,r16			; make copy of swaped r16	MSB
		andi	r19,0x0F
		andi	r16,0xF0
		or		r16,r19			; r16 = new 1/2 MSB + 1/2 LSB
		andi	r18,0x0F		; r18 = new 1/2 MSB
		sbiw	Y,3
		st		Y+,r17			; rawTemp XLSB (7:0)
		st		Y+,r16			; rawTemp LSB  (15:8)
		st		Y+,r18			; rawTemp MSB  (23:16)
		ld		r16,Y+			; rawHumidity MSB  (7:0)
		ld		r17,Y+			; rawHumidity LSB  (7:0)
		sbiw	Y,2
		st		Y+,r17			; rawHumidity XLSB (7:0)
		st		Y+,r16			; rawHumidity LSB  (15:8)
		ret

;------------------------------------------------------------------------------------------------------------------------------------------
