;******************************************************************************
;*
;* FUNCTION
;*	muls16x16_32
;* DECRIPTION
;*	Signed multiply of two 16bits numbers with 32bits result.
;* USAGE		E3:E2:E1:E0 =  AH:AL  *  BH:BL
;*				r5:r4:r3:r2 = r21:r20 * r17:r16
;* STATISTICS
;*	Cycles :	19 + ret
;*	Words :		15 + ret
;*	Scrached Register usage: r6
;* NOTE
;*	The routine is non-destructive to the operands.
;*
;******************************************************************************

muls_16x16:
		push	R6
		clr		R6
		muls	R21,R17			; (signed)ah * (signed)bh
		movw	R5:R4,R1:R0
		mul		R20,R16			; al * bl
		movw	R3:R2,R1:R0
		mulsu	R21, R16		; (signed)ah * bl
		sbc		R5, R6
		add		R3, R0
		adc		R4, R1
		adc		R5, R6
		mulsu	R17, R20		; (signed)bh * al
		sbc		R5, R6
		add		R3, R0
		adc		R4, R1
		adc		R5, R6
		pop		R6
		ret
