;***************************************************
;* Mutiply 24x16 -> 64 bit
;*       AH  AM  AL   BH  BL     E4 E3 E2 E1 E0
;*      R22:R21:R20 x R17:R16 -> R6:R5:R4:R3:R2
;*
;*  108 cycles + 4 (RET) = 112 Cycles
;*
muls_24x16:
		push	R10		
		clr		R10
		mul		R20,R16			; AL x BL
		movw	R3:R2,R1:R0		; r1:r0 -> E1:E0
		muls	R22,R17			; AH x BH
		mov		R5,R0			; r0 -> E3
		mov		R6,R1			; r1 -> E4
		clr		R4				;clr -> E2
		
		mul		R21,R16			; AM x BL
		add		R3,R0			; r0 -> E1
		adc		R4,R1			; r1 -> E2
		
		mulsu	R22,R16			; AH x BL
		sbc		R6,R10			; signed DUMMY T4
		add		R4,R0			; r0 -> E2
		adc		R5,R1			; r1 -> E3
		adc		R6,R10			; T4 -> E4

		mulsu	R17,R20			; AL x BH  ->  BH x AL
		sbc		R5,R10			; signed DUMMY T3
		sbc		R6,R10			; signed DUMMY T4
		add		R3,R0			; r0 -> E1
		adc		R4,R1			; r1 -> E2
		adc		R5,R10			; T3 -> E3
		adc		R6,R10			; T4 -> E4
		
		mulsu	R17,R21			; AM x BH  ->  BH x AM
		sbc		R6,R10			; signed DUMMY T4
		add		R4,R0			; r0 -> E2
		adc		R5,R1			; r1 -> E3
		adc		R6,R10			; T4 -> E4
		pop		R10  
		ret