;***************************************************
;* Mutiply 24x16 -> 64 bit
;*       AH  AM  AL   BH  BM  BL     E5 E4 E3 E2 E1 E0
;*      R22:R21:R20 x R18:R17:R16 -> R7:R6:R5:R4:R3:R2
;*
;*  108 cycles + 4 (RET) = 112 Cycles
;*
muls_24x24:
		push	R8
		push	R9
		push	R10
		clr		R10
		mul		R20,R16			; AL x BL
		movw	R3:R2,R1:R0		; r1:r0 -> E1:E0
		mul		R21,R17			; AL x BL
		movw	R5:R4,R1:R0		; r1:r0 -> E3:E2
		muls	R22,R17			; AH x BH
		movw	R7:R6,R1:R0		; r1:r0 -> E5:E4
		
		mulsu	R22,R17			; AH x BM
		sbc		R7,R10			; signed DUMMY T2
		movw	R9:R8,R1:R0		; r1:r0 -> T1:T0
		mul		R21,R16			; AM x BL
		add		R3,R0			; R0 -> E1
		adc		R4,R1			; R1 -> E2
		adc		R5,R8			; T0 -> E3
		adc		R6,R9			; T1 -> E4
		adc		R7,R10			; T2 -> E5
		
		mulsu	R18,R21			; AM x BH  ->  BH x AM
		sbc		R7,R10			; signed DUMMY T2
		movw	R9:R8,R1:R0		; r1:r0 -> T1:T0
		mul		R20,R17			; AL x BM
		add		R3,R0			; R0 -> E1
		adc		R4,R1			; R1 -> E2
		adc		R5,R8			; T0 -> E3
		adc		R6,R9			; T1 -> E4
		adc		R7,R10			; T2 -> E5

		mulsu	R22,R16			; AH x BL
		sbc		R6,R10			; signed DUMMY T2
		sbc		R7,R10			; signed DUMMY T2
		adc		R4,R0			; R0 -> E2
		adc		R5,R1			; R1 -> E3
		adc		R6,R10			; T2 -> E4
		adc		R7,R10			; T2 -> E5

		mulsu	R18,R20			; AL x BH -> BH x AL
		sbc		R6,R10			; signed DUMMY T2
		sbc		R7,R10			; signed DUMMY T2
		adc		R4,R0			; R0 -> E2
		adc		R5,R1			; R1 -> E3
		adc		R6,R10			; T2 -> E4
		adc		R7,R10			; T2 -> E5
		pop		R10
		pop		R9
		pop		R8  
		ret