;***************************************************
;* Mutiply 32x16 -> 48 bit
;*  AH   AM  AL AXL   BH  BL     E5 E4 E3 E2 E1 E0
;*  R23:R22:R21:R20 x R17:R16 -> R7:R6:R5:R4:R3:R2
;*
;*  56 cycles + 4 (RET) = 60 Cycles
;*
muls_32x16:
		push	R8
		push	R9
		push	R10	
		clr		R10
		mul		R20,R16			; AXL x BL
		movw	R3:R2,R1:R0		; r1:r0 -> E1:E0
		mul		R22,R16			; AM x BL
		movw	R5:R4,R1:R0		; r1:r0 -> E3:E2
		muls	R23,R17			; AH x BH
		movw	R7:R6,R1:R0		; r1:r0 -> E5:E4

		mulsu	R23,R16			; AH x BL
		movw	R9:R8,R1:R0		; r1:r0 -> T4:T3
		sbc		R7,R10			; signed DUMMY T5	
		mul		R21,R16			; AL x BL
		add		R3,R0			; r0 ----> + E1
		adc		R4,R1			; r1 +c -> + E2
		adc		R5,R8			; T3 +c -> + E3
		adc		R6,R9			; T4 +c -> + E4
		adc		R7,R10			; T5 +c -> + E5

		mulsu	R17,R20			; AXL x BH -> BH x AXL
		sbc		R5,R10			; signed DUMMY T5
		sbc		R6,R10			; signed DUMMY T5
		sbc		R7,R10			; signed DUMMY T5
		add		R3,R0			; r0 ----> + E1
		adc		R4,R1			; r1 +c -> + E2
		adc		R5,R10			; T5 +c -> + E3
		adc		R6,R10			; T5 +c -> + E4
		adc		R7,R10			; T5 +c -> + E5
		
		mulsu	R17,R21			; AL x BH -> BH x AL
		sbc		R6,R10			; signed DUMMY T5
		sbc		R7,R10			; signed DUMMY T5
		add		R4,R0			; r0 +c -> + E2
		adc		R5,R1			; r1 +c -> + E3
		adc		R6,R10			; T5 +c -> + E4
		adc		R7,R10			; T5 +c -> + E5
		
		mulsu	R17,R22			; BH x AM
		sbc		R7,R10			; signed DUMMY T5
		add		R5,R0			; r0 +c -> + E3
		adc		R6,R1			; r1 +c -> + E4
		adc		R7,R10			; T5 +c -> + E5
		pop		R10
		pop		R9
		pop		R8	
		ret
