;***************************************************
;* Mutiply 32x32 -> 64 bit
;*  AH   AM  AL AXL   BH  BM  BL  BXL    E7 E6 E5 E4 E3 E2 E1 E0
;*  R23:R22:R21:R20 x R19:R18:R17:R16 -> R9:R8:R7:R6:R5:R4:R3:R2
;*
;*  108 cycles + 4 (RET) = 112 Cycles
;*
muls_32x32:
		push	R10
		push	R11
		push	r12
		push	r13
		push	r14
		clr		R14
		mul		R20,R16			; AXL x BXL
		movw	R3:R2,R1:R0		; r1:r0 -> E1:E0
		mul		R21,R17			; AL x BL
		movw	R5:R4,R1:R0		; r1:r0 -> E3:E2
		mul		R22,R18			; AM x BM
		movw	R7:R6,R1:R0		; r1:r0 -> E5:E4
		muls	R23,R19			; AH x BH
		movw	R9:R8,R1:R0		; r1:r0 -> E7:E6

		mulsu	R23,R18			; AH x BM
		movw	R13:R12,R1:R0	; r1:r0 -> T5:T4
		sbc		R9,R14			; signed DUMMY T6
		mul		R22,R17			; AM x BL
		movw	R11:R10,R1:R0	; r1:r0 -> T3:T2
		mul		R21,R16			; AL x BXL
		add		R3,R0			; r0 ----> + E1
		adc		R4,R1			; r1 +c -> + E2
		adc		R5,R10			; T2 +c -> + E3
		adc		R6,R11			; T3 +c -> + E4
		adc		R7,R12			; T4 +c -> + E5
		adc		R8,R13			; T5 +c -> + E6
		adc		R9,R14			; T6 +c -> + E7

		mulsu	R19,R22			; AM x BH -> BH x AM
		movw	R13:R12,R1:R0	; r1:r0 -> T5:T4
		sbc		R9,R14			; signed DUMMY T6
		mul		R21,R18			; AL x BM
		movw	R11:R10,R1:R0	; r1:r0 -> T3:T2
		mul		R20,R17			; AXL x BL
		add		R3,R0			; r0 ----> + E1
		adc		R4,R1			; r1 +c -> + E2
		adc		R5,R10			; T2 +c -> + E3
		adc		R6,R11			; T3 +c -> + E4
		adc		R7,R12			; T4 +c -> + E5
		adc		R8,R13			; T5 +c -> + E6
		adc		R9,R14			; T6 +c -> + E7

		mulsu	R23,R17			; AH x BL
		movw	R11:R10,R1:R0	; r1:r0 -> T3:T2
		sbc		R9,R14			; signed DUMMY T6
		sbc		R8,R14			; signed DUMMY T6
		mul		R20,R18			; AXL x BM
		add		R4,R0			; r0 +c -> + E2
		adc		R5,R1			; r1 +c -> + E3
		adc		R6,R10			; T3 +c -> + E4
		adc		R7,R11			; T4 +c -> + E5
		adc		R8,R14			; T5 +c -> + E6
		adc		R9,R14			; T6 +c -> + E7

		mulsu	R19,R21			; AL x BH -> BH x AL
		movw	R11:R10,R1:R0	; r1:r0 -> T3:T2
		sbc		R9,R14			; signed DUMMY T6
		sbc		R8,R14			; signed DUMMY T6
		mul		R22,R16			; AM x BXL
		add		R4,R0			; r0 +c -> + E2
		adc		R5,R1			; r1 +c -> + E3
		adc		R6,R10			; T3 +c -> + E4
		adc		R7,R11			; T4 +c -> + E5
		adc		R8,R14			; T5 +c -> + E6
		adc		R9,R14			; T6 +c -> + E7

		mulsu	R19,R20			; AXL x BH -> BH x AXL
		sbc		R9,R14			; signed DUMMY T6
		sbc		R8,R14			; signed DUMMY T6
		sbc		R7,R14			; signed DUMMY T6
		add		R5,R0			; r0 +c -> + E3
		adc		R6,R1			; r1 +c -> + E4
		adc		R7,R14			; T6 +c -> + E5
		adc		R8,R14			; T6 +c -> + E6
		adc		R9,R14			; T6 +c -> + E7

		mulsu	R23,R16			; AH x BXL
		sbc		R9,R14			; signed DUMMY T6
		sbc		R8,R14			; signed DUMMY T6
		sbc		R7,R14			; signed DUMMY T6
		add		R5,R0			; r0 +c -> + E3
		adc		R6,R1			; r1 +c -> + E4
		adc		R7,R14			; T6 +c -> + E5
		adc		R8,R14			; T6 +c -> + E6
		adc		R9,R14			; T6 +c -> + E7
		pop		R14
		pop		R13
		pop		R12
		pop		R11
		pop		R10  
		ret
