;***************************************************
;* Mutiply 32x8 -> 40 bit
;*       AH  AM  AL AXL   BL     E4 E3 E2 E1 E0
;*      R23:R22:R21:R20 x R16 -> R6:R5:R4:R3:R2
;*
;*  19 cycles + 4 (RET) = 23 Cycles
;*
muls_32x8:
		push	R10
		clr		R10
		clr		R6
		clr		r5
		clr		r4
		mulsu	R16,R20			; BL x AXL
		movw	R3:R2,R1:R0		; r1:r0 -> E1:E0
		mulsu	R16,R21			; BL x AL	
		sbc		R5,R10			; signed DUMMY T0
		sbc		R6,R10			; signed DUMMY T0
		add		R3,R0			; R0 -> E1
		adc		R4,R1			; R1 -> E2
		adc		R5,R10			; T0 -> E3
		adc		R6,R10			; T0 -> E4
		mulsu	R16,R22			; BL x AM
		sbc		R6,R10			; signed DUMMY T0
		add		R4,R0			; R0 -> E2
		adc		R5,R1			; R1 -> E3
		adc		R6,R10			; T0 -> E4
		muls	R16,R23			; BL x AH
		add		R5,R0			; R0 -> E3
		adc		R6,R1			; R1 -> E4
		pop		R10
		ret