;***************************************************
;* Mutiply 32x8 -> 40 bit
;*       AH  AM  AL AXL   BL     E4 E3 E2 E1 E0
;*      R23:R22:R21:R20 x R16 -> R6:R5:R4:R3:R2
;*
;*  19 cycles + 4 (RET) = 23 Cycles
;*
mulsu_32x8:
		push	R10
		clr		R10
		clr		r4
		mul		R20,R16			; AXL x BL
		movw	R3:R2,R1:R0		; r1:r0 -> E1:E0
		mulsu	R23,R16			; AH x BL
		mov		R5,R0			; r0 -> E0
		mov		R6,R1			; r1 -> E0
		mul		R21,R16			; AL x BL	
		add		R3,R0			; R0 -> E1
		adc		R4,R1			; R1 -> E2
		adc		R5,R10			; T0 -> E3
		adc		R6,R10			; T0 -> E4
		mul		R22,R16			; AM x BL
		add		R4,R0			; R0 -> E2
		adc		R5,R1			; R1 -> E3
		adc		R6,R10			; T0 -> E4
		pop		R10
		ret